{
 RS232 Interface zur Nutzung in Windows 7 Anwendungen

(c) Dipl.-Ing. Thomas Neveling 22/08/2016
 Version 1.00, letzte nderung 22/08/2016
}
UNIT RS232;

INTERFACE

USES Windows, Sysutils;

PROCEDURE TIMEOUTS (TOut : INTEGER);
FUNCTION OPENCOM (OpenString : pchar) : INTEGER;
PROCEDURE CLOSECOM;
PROCEDURE SENDBYTE (Dat : INTEGER);
FUNCTION READBYTE : INTEGER;

IMPLEMENTATION

VAR PortHandle : THandle;

PROCEDURE TIMEOUTS (TOut : INTEGER);
VAR       TimeOut : TCOMMTIMEOUTS;
BEGIN { TIMEOUTS }
 TimeOut.ReadIntervalTimeout:= 1;
 TimeOut.ReadTotalTimeoutMultiplier:= 1;
 TimeOut.ReadTotalTimeoutConstant:= TOut;
 TimeOut.WriteTotalTimeoutMultiplier:= 10;
 TimeOut.WriteTotalTimeoutConstant:= TOut;
 SetCommTimeouts (PortHandle, TimeOut)
END { TIMEOUTS };

FUNCTION OPENCOM (OpenString : pchar) : INTEGER;
VAR      OpenStr, PortStr, Parameter : STRING;
         DCB : TDCB;
         P   : Byte;
BEGIN { OPENCOM }
 Result:= 0;
 IF PortHandle > 0 THEN CloseHandle (PortHandle);
 OpenStr:= OpenString;
 P:= Pos (':', OpenStr);
 IF P = 5 THEN
  BEGIN        // COM1: - COM9:
   PortStr:= Copy (OpenStr, 1, 4);
   Parameter:= Copy (OpenStr, 6, Length (OpenStr) - 6)
  END { if P }
 ELSE
  BEGIN        // COM10: - COM99:
   PortStr:= Copy (OpenStr, 1, 5);
   PortStr:= '\\.\' + PortStr;
   Parameter:= Copy (OpenStr, 7, Length (OpenStr) - 7)
  END { else };
 PortHandle:= CreateFile (PChar (PortStr), GENERIC_READ OR GENERIC_WRITE, 0, NIL, OPEN_EXISTING, 0, 0);
 GetCommState (PortHandle, DCB);
 BuildCommDCB (PChar (Parameter), dcb);
 DCB.Flags:= 1;
 IF SetCommState (PortHandle, DCB) THEN Result:= 1
END { OPENCOM };

PROCEDURE CLOSECOM;
BEGIN
 CloseHandle (PortHandle);
 PortHandle:= 0
END;

PROCEDURE SENDBYTE (Dat : INTEGER);
VAR       BytesWritten : DWord;
BEGIN { SENDBYTE }
 WriteFile (PortHandle, Dat, 1, BytesWritten, NIL)
END { SENDBYTE };

FUNCTION READBYTE : INTEGER;
VAR      Dat      : BYTE;
         BytesRead: DWORD;
BEGIN { READBYTE }
 ReadFile (PortHandle, Dat, 1, BytesRead, NIL);
 IF BytesRead = 1 THEN Result:= Dat ELSE Result:= -1
END { READBYTE };

END.
